'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = fetch;

var _scope;

function _load_scope() {
  return _scope = require('../../../scope');
}

var _bitId;

function _load_bitId() {
  return _bitId = require('../../../bit-id');
}

var _constants;

function _load_constants() {
  return _constants = require('../../../constants');
}

var _hooks;

function _load_hooks() {
  return _hooks = _interopRequireDefault(require('../../../hooks'));
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var HooksManagerInstance = (_hooks || _load_hooks()).default.getInstance();

function fetch(path, ids) {
  var noDependencies = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;

  var bitIds = (_bitId || _load_bitId()).BitIds.deserialize(ids);
  var args = { path, bitIds, noDependencies };
  HooksManagerInstance.triggerHook((_constants || _load_constants()).PRE_SEND_OBJECTS, args);
  return (0, (_scope || _load_scope()).loadScope)(path).then(function (scope) {
    if (noDependencies) return scope.manyOneObjects(bitIds);
    return scope.getObjects(bitIds).then(function (componentObjects) {
      HooksManagerInstance.triggerHook((_constants || _load_constants()).POST_SEND_OBJECTS, {
        componentObjects,
        scopePath: path,
        componentsIds: bitIds.serialize(),
        scopeName: scope.scopeJson.name
      });
      return componentObjects;
    });
  });
}