'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = put;

var _scope;

function _load_scope() {
  return _scope = require('../../../scope');
}

var _componentObjects;

function _load_componentObjects() {
  return _componentObjects = _interopRequireDefault(require('../../../scope/component-objects'));
}

var _constants;

function _load_constants() {
  return _constants = require('../../../constants');
}

var _hooks;

function _load_hooks() {
  return _hooks = _interopRequireDefault(require('../../../hooks'));
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var HooksManagerInstance = (_hooks || _load_hooks()).default.getInstance();

function put(_ref) {
  var path = _ref.path,
      componentObjects = _ref.componentObjects;

  if (typeof componentObjects === 'string') {
    componentObjects = (_componentObjects || _load_componentObjects()).default.manyFromString(componentObjects);
  }
  HooksManagerInstance.triggerHook((_constants || _load_constants()).PRE_RECEIVE_OBJECTS, { path, componentObjects });

  return (0, (_scope || _load_scope()).loadScope)(path).then(function (scope) {
    return scope.exportManyBareScope(componentObjects).then(function (componentsIds) {
      HooksManagerInstance.triggerHook((_constants || _load_constants()).POST_RECEIVE_OBJECTS, {
        componentObjects,
        componentsIds,
        scopePath: path,
        scopeName: scope.scopeJson.name
      });
      return componentsIds;
    });
  });
}